local Crumbles = require("lib.classic"):extend()


function Crumbles:crumble(pixelRate)
  
  --Create quads of every pixel
  self.crumbling = 0
  
  self.crumbleRate = pixelRate
  
  for x = 0, self.texture:getWidth()-1 do
    for y = 0, self.texture:getHeight()-1 do
      
      --CrumblePixel(self.texture.main or self.texture, self, x, y)

    end
  end
  
end



function Crumbles:crumbleUpdate(dt)
  
  if self.crumbling then
    self.crumbling = self.crumbling + dt*self.crumbleRate
    if self.crumbling >= 10 then
      self:finishCrumbling()
    end
  end
  
end


function Crumbles:finishCrumbling()
  
  self.crumbling = nil
  cout("IOU Crumbling animation")
  
end



return Crumbles