LevelLoader = Interactable:extend()
LevelLoader.type = "levelLoader"
local screenFader = require "UI.screenFader"

function LevelLoader:new(x, y, attributes)
  LevelLoader.super.new(self, x, y, attributes)
  
  createAttribute(self.attributes, "levelName", "overworld")
  createAttribute(self.attributes, "spawnPoint", "sp_unnamed")
end



function LevelLoader:activate()
  
  screenFader:fadeOut(1, 
    function(fader)
      self:loadLevel()
      fader:fadeIn(0.5)
      
      player1:spawn(self.attributes.spawnPoint)
      
    end
  )
  
  
end


function LevelLoader:loadLevel()
  
  currentLevel:loadLevel(self.attributes.levelName)
  
end
