function Player:endContactCallback(a, b, coll)
  self.collisionTable[a] = nil
  self.collisionTable[b] = nil
end


function Player:preSolveCallback(a, b, coll)
  --fuuuuuuuck i'm gonna need to calculate the normal inpulse  myself
    
  local normal = Vec2(coll:getNormal())
  
  local aVel = Vec2(a:getBody():getLinearVelocity())
  local bVel = Vec2(b:getBody():getLinearVelocity())
  local relativeVelocity = bVel - aVel
  local normalVelocity = vector.project(relativeVelocity, normal)
  

  local playerMass = self.body:getMass()
  local restitution = math.max(a:getRestitution(), b:getRestitution())
  local vel = vector.getMagnitude(normalVelocity)
  
  
  --For some reason the real collision impulse is consistently 1.25* higher than my own value, but never precisely. Unsure what I'm missing here
  
  local impulse = math.abs(vel * coll:getRestitution()) * 1.25
  
  if impulse >= 200 and (not self.tucked) and (not (self.bonkImmunity > 0)) then
    self.body:setFixedRotation(false)
    self.bonked = 1.5
  end

end



function Player:postSolveCallback(a, b, coll, normalimpulse, tangentimpulse)
  if not self:isParrying() then
    if (normalimpulse > 80 and self.parried <= 0) or normalimpulse > 400 then
      sound.effect.thud:setVolume((normalimpulse-60)/200)
      sound.effect.thud:play()
    end
  end
  
  local other
  local player
  
  if a:getUserData() == "player" then
    other = b
    player = a
  else
    other = a
    player = b
  end
  self.collisionImpulse = normalimpulse
  

  local normalVector = Vec2(coll:getNormal( ))
  local collDisplacement = Vec2(coll:getPositions()) - self:getPosition()
  
  normalVector = normalVector * -lume.sign(vector.dotProduct(normalVector, collDisplacement))
  
  table.insert(self.collisionTable, normalVector)
end




function Player:getCollisionVectors()
  
  
  self.contactWithGround = #self.collisionTable > 0
  if not self.contactWithGround then
    return
  end
  
  local trueAverageNormal = Vec2(0,0)
  local averageNormal = Vec2(0,0)
  local averageVelocity = Vec2(0, 0)
  for i, v in pairs(self.collisionTable) do
    trueAverageNormal = averageNormal + v
    --Check to see if the surfaces are valid for walking on
    if self:canWalkPart(v) then
      averageNormal = averageNormal + v
    end
  end
  trueAverageNormal = vector.normalize(trueAverageNormal)
  averageNormal = vector.normalize(averageNormal)
  
  self.tangentWithGround = vector.turn90Degrees(vector.normalize(averageNormal))
  local relativeVelocity = self.velocityLastFrame - averageNormal
  self.tangentVelocity = vector.project(relativeVelocity, player1.tangentWithGround)
  self.walkableNormalVelocity = vector.project(relativeVelocity, averageNormal)
  self.normalVelocity = vector.project(relativeVelocity, trueAverageNormal)
  self.trueNormalWithGround = trueAverageNormal 
  self.normalWithGround = averageNormal
  
end


function Player:clearCollisionTable()
  
  self.collisionTable = {}
end
