local events = {}
local nameIndex = require "nameIndex"
local Event = require("lib.classic"):extend()

function Event:new(name)
  self.name = name
  table.insert(events, self)
end


local waterTest = Event("WaterTest")

function waterTest:activate()
  
  local level = player1:getY()
  
  nameIndex:executeAll("WaterTestBlock", function(block) block:setLevel(level) end, args)
  
end




for i, event in ipairs(events) do
  
  nameIndex:addEntity(event, event.name)
  
end



return events