local book = require "dialogue/bookFunctions"
local say = book.say


return function(speaker)
  
  event.met_cordelia = true
  
  say("Drea", "Cordelia!")
  say("Cordelia", "Oh hello Drea! It has been a while.")
  say("Drea", "Don't take this the wrong way, but... you were definately dead last time I met you.$$$$$$ And where's Elara?")
  say("Cordelia", "I'm... not sure. I believe she's here... she has to be. I just hope Volt finds her...")
  
  if event.met_volt then
    say("Drea", "I met him earlier - he seems to be having trouble with all the climbing.")
    say("Cordelia", "I see... then maybe you would be a better at looking dear?")
    say("Drea", "That would probably be a good idea, I wouldn't want him to get hurt.")
    say("Cordelia", "I don't think it's actually possible to get injured here! Between you and me, I think you might be able to take greater advantage of that.")
    say("Drea", "What do you mean?")
    say("Cordelia", "If you tuck into a ball just before you hit something, you can roll for a short time across it!")
    say("Cordelia", "Oh, also in case you hadn't noticed, you can click to fire fireballs, and press "..controls.timeBubble.name.." to use your time bubble ability.")
    say("Drea", "That's a little on the nose don't you think?")
    say("Cordelia", "Does this game look like it has a budget? Proper ability introductions will come later.")
    say("Drea", "Well, thats good to know! Thanks!")
  else
    say("Drea", "Volt's here? I haven't seen him yet, where is he?")
    say("Cordelia", "He's further up in the caves, he was trying to reach the other side of the island.")
    say("Drea", "I'll go look for him, he can't be too far.")
    say("Cordelia", "Good luck Drea! Come back here when you're done.")
  end
  
  book.endDialogue()
  
  
  while not event.met_volt do
    say("Drea", "Could I have a reminder of where Voltehre is?")
    say("Cordelia", "He's further up in the caves, he was trying to reach the other side of the island.")
    say("Drea", "Thank you!")
    say("Cordelia", "Good luck Drea! Come back here when you're done.")
    book.endDialogue()
  end
  
  while true do
    say("Drea", "So... what's next?")
    say("Cordelia", "I'm not really sure, though I would very much like to find Elara.")
    say("Drea", "There isn't anything else in this demo is there?")
    say("Cordelia", "I'm afraid not dear, so just play around with the movement! The sooner we get this nailed, the sooner we can work on the rest of the story.")
    book.endDialogue()
  end
  
  
end