local manifest = {}

local function getBook(book)
  return require("dialogue."..book)
end


manifest.test                   = getBook("testbook")
manifest.volt_intro             = getBook("volt.intro")
manifest.cordelia_intro         = getBook("cordelia.intro")

manifest.backpack               = getBook("objects.backpack")

manifest.ds_island_1_west       = getBook("direction stones.island 1 west")
manifest.ds_island_1_east       = getBook("direction stones.island 1 east")

manifest.mural_volt_intro       = getBook("murals.volt.volt intro")
manifest.mural_volt_1           = getBook("murals.volt.volt 1")
manifest.mural_volt_2           = getBook("murals.volt.volt 2")
manifest.mural_volt_3           = getBook("murals.volt.volt 3")
manifest.mural_volt_4           = getBook("murals.volt.volt 4")

return manifest