local book = require "dialogue/bookFunctions"
local say = book.say


return function(speaker)
  
  event.met_volt = true
  
  say("Drea", "...Volt? Volt is that you?")
  say("Voltehre", "Ah, Drea! So you're here with us too! How nice to see you, this place is rather odd don't you think?")
  say("Drea", "I wasn't expecting to see you... ever... it's been so long...")
  say("Voltehre", "Ah, it's slightly hard to gauge time in the spirit realm - a day can feel as long as a century! But here though - I can positively feel it's flow!")
  
  if event.drea.knows.volt_murals then
    say("Drea", "This is a strange place… I saw a sort of broken floating bridge, as well as a bunch of murals... about you.")
  else
    say("Drea", "This is a strange place... I saw a sort of broken floating bridge earlier.")
  end
  say("Voltehre", "It's quite interesting! It took me a while to get up here, though I've found a few things in the process. We seem to be on some kind of floating island, which is unusual to say the least.")
  say("Drea", "Where do you think we are then?")
  say("Voltehre", "If we are to take his word at face value, this is a realm created by the Curator, though this wouldn't be the first time I've met someone pretending to be omnipotent.")
  say("Drea", "Who's the Curator?")
  say("Voltehre", "You haven't met him yet? Best to let him do the explaining, he's rather... odd.")
  say("Drea", "If you're sure... is there anyone else here I should know about?")
  say("Voltehre", "Cordelia is on the lower levels of the island if you want to find her.")
  
  if event.met_cordelia then
    
    say("Drea", "I met her earlier, she seemed a bit anxious to find Elara.")
    say("Voltehre", "I'm afraid that until we know more about this place, we can't be sure she's even here. I'll keep looking though.")
    say("Drea", "I hope so... I should probably get going.")
    
  else
    say("Drea", "Thanks, I'll be on the lookout for her.")
  end
  say("Voltehre", "Always a pleasure Drea... now, I think I might enjoy the view a little longer before I climb down.")
  book.endDialogue()
  
  while true do
    say("Voltehre", "By the way, it would be much easier if you carried me down.")
    say("Drea", "You know how I feel about that...")
    say("Voltehre", "I know, but... *sigh*")
    book.endDialogue()
  end
  
end