Talkative = Interactable:extend()
Talkative.type = "talkative"

local specialDialogue = require "entities/interactables/special dialogue"

function Talkative:new(x, y, attributes)
  Talkative.super.new(self, x, y, attributes)
  self.isTalkative = true
  createAttribute(self.attributes, "book", "boop")
  createAttribute(self.attributes, "focusCamera", true)
end



function Talkative:activate()
  if not dialogueBox.displayed then
    self:playDialogue()
  end
end



function Talkative:playDialogue()
  
  if self:showBook() then
  
    if self.attributes.focusCamera then
      camera.targetPoint = Vec2((player1.body:getX() + self.x)/2, (player1.body:getY() + self.y)/2)
      camera.targetZoom = 5
    end
  
  end
  
end

function Talkative:showBook()
  return dialogueBox:loadBook(self.attributes.book, self)
end
  

  



    
    