PhysicsItem = Entity:extend()
PhysicsItem.type = "physicsItem"

function PhysicsItem:new(x, y, shape)
  
  PhysicsItem.super.new(self)
  
  self.body = love.physics.newBody(world, x, y, "dynamic")
  self.shape = shape
  self.fixture = love.physics.newFixture(self.body, self.shape, 1)
  self.fixture:setUserData(self)
  
  table.insert(drawTable, self)
  
  
end


function PhysicsItem:getX()
  return self.body:getX()
end

function PhysicsItem:getY()
  return self.body:getY()
end


function PhysicsItem:getVelocity()
  return self.body:getVelocity()
end