local function settingRange(input, min, max, varType)
  return min(input, 1)
end

local _, _, flags = love.window.getMode()


local settings = {}
settings.graphics = {}
settings.graphics.particleAmount = 1
settings.graphics.lightingCompatibility =  true --Whether the depth map uses r16f or rgba16f
settings.graphics.vsync = 0
settings.graphics.fastLighting = false

if flags.refreshrate < 50 then
  settings.graphics.vsync = 0
else
  settings.graphics.vsync = 1
end


settings.game = {}
settings.game.flightAssist = false

settings.audio = {}
settings.audio.master = 1
settings.audio.music = 1
settings.audio.effects = 1


return settings